/* MainWindow.c generated by valac 0.48.13, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
* Copyright © 2018–2020 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;
typedef enum  {
	MAIN_WINDOW_RANGE_LOW,
	MAIN_WINDOW_RANGE_LODPI_LOW,
	MAIN_WINDOW_RANGE_LODPI_IDEAL,
	MAIN_WINDOW_RANGE_LODPI_HIGH,
	MAIN_WINDOW_RANGE_HIDPI_LOW,
	MAIN_WINDOW_RANGE_HIDPI_IDEAL,
	MAIN_WINDOW_RANGE_HIDPI_HIGH,
	MAIN_WINDOW_RANGE_HIGH,
	MAIN_WINDOW_RANGE_UNCLEAR,
	MAIN_WINDOW_RANGE_INVALID
} MainWindowRange;

#define MAIN_WINDOW_TYPE_RANGE (main_window_range_get_type ())
typedef enum  {
	UTILS_DISPLAY_TYPE_INTERNAL,
	UTILS_DISPLAY_TYPE_EXTERNAL
} UtilsDisplayType;

#define UTILS_TYPE_DISPLAY_TYPE (utils_display_type_get_type ())
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	gint aspect_width;
	gint aspect_height;
	gdouble inches;
	gint width;
	gint height;
	gboolean is_default_display_type;
	gboolean is_default_width;
	gboolean is_default_height;
	gchar* direction;
	GtkImage* diagram;
	GtkEntry* diag_entry;
	GtkEntry* width_entry;
	GtkEntry* height_entry;
	GtkLabel* dpi_result_label;
	GtkLabel* logical_resolution_label;
	GtkLabel* aspect_result_label;
	GraniteWidgetsModeButton* type_modebutton;
	GtkLabel* range_title_label;
	GtkLabel* range_description_label;
	GtkImage* range_icon;
	MainWindowRange range;
	UtilsDisplayType display_type;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;

GType main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
static GType main_window_range_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType utils_display_type_get_type (void) G_GNUC_CONST;
static gchar* main_window_range_title (MainWindowRange self);
static gchar* main_window_range_description (MainWindowRange self);
static gchar* main_window_range_icon (MainWindowRange self);
#define MAIN_WINDOW_DEFAULT_ASPECT_WIDTH 16
#define MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT 9
#define MAIN_WINDOW_INTERNAL_IDEAL_DPI 140
#define MAIN_WINDOW_INTERNAL_IDEAL_RANGE 16
#define MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE 14
#define MAIN_WINDOW_EXTERNAL_IDEAL_DPI 120
#define MAIN_WINDOW_EXTERNAL_IDEAL_RANGE 30
#define MAIN_WINDOW_EXTERNAL_UNCLEAR_RANGE 20
#define MAIN_WINDOW_INCHES_INFER_EXTERNAL ((gdouble) 18)
#define MAIN_WINDOW_DPI_INFER_HIDPI 192
MainWindow* main_window_new (GtkApplication* application);
MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static gint main_window_recalculate_dpi (MainWindow* self,
                                  gdouble inches,
                                  gint width,
                                  gint height);
gint utils_dpi (gdouble inches,
                gint width,
                gint height);
static void main_window_recalculate_logical_resolution (MainWindow* self,
                                                 gint width,
                                                 gint height,
                                                 gint dpi);
static void main_window_recalculate_aspect (MainWindow* self,
                                     gint width,
                                     gint height);
gint utils_greatest_common_divisor (gint a,
                                    gint b);
static void main_window_assess_dpi (MainWindow* self,
                             gdouble calculated_dpi,
                             UtilsDisplayType display_type);
static UtilsDisplayType main_window_infer_display_type (MainWindow* self,
                                                 gdouble inches);
static void main_window_set_display_icon (MainWindow* self);
gchar* utils_display_type_icon_suffix (UtilsDisplayType self);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _main_window___lambda4_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda4__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
static gboolean _main_window___lambda5_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
static gboolean _main_window___lambda6_ (MainWindow* self,
                                  GdkEventFocus* event);
static gboolean __main_window___lambda6__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self);
gchar* utils_display_type_to_string (UtilsDisplayType self);
static void _main_window___lambda7_ (MainWindow* self);
static void __main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda8_ (MainWindow* self);
static void __main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda9_ (MainWindow* self);
static void __main_window___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda10_ (MainWindow* self);
static void __main_window___lambda10__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                         GtkWidget* widget,
                                                                         gpointer self);
static void main_window_finalize (GObject * obj);
static GType main_window_get_type_once (void);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

static gchar*
main_window_range_title (MainWindowRange self)
{
	gchar* result = NULL;
	switch (self) {
		case MAIN_WINDOW_RANGE_LOW:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Very Low DPI"));
			result = _tmp0_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_LOW:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Fairly Low DPI"));
			result = _tmp1_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Ideal for LoDPI"));
			result = _tmp2_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
		case MAIN_WINDOW_RANGE_UNCLEAR:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Potentially Problematic"));
			result = _tmp3_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Ideal for HiDPI"));
			result = _tmp4_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Fairly High for HiDPI"));
			result = _tmp5_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIGH:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Too High DPI"));
			result = _tmp6_;
			return result;
		}
		case MAIN_WINDOW_RANGE_INVALID:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Analyze a Display"));
			result = _tmp7_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static gchar*
main_window_range_description (MainWindowRange self)
{
	gchar* result = NULL;
	switch (self) {
		case MAIN_WINDOW_RANGE_LOW:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Text and UI are likely to be too big for typical viewing distances. Av" \
"oid if possible."));
			result = _tmp0_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_LOW:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Text and UI might be too big for typical viewing distances, but it's l" \
"argely up to user preference and physical distance from the display."));
			result = _tmp1_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Not HiDPI, but a nice sweet spot. Text and UI should be legible at typ" \
"ical viewing distances."));
			result = _tmp2_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Relatively high resolution, but not quite HiDPI. Text and UI may be to" \
"o small by default, but forcing HiDPI would make them appear too large" \
". The experience may be slightly improved by increasing the text size."));
			result = _tmp3_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("HiDPI by default, but text and UI may appear too large. Turning off Hi" \
"DPI and increasing the text size might help."));
			result = _tmp4_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Crisp HiDPI text and UI along with a readable size at typical viewing " \
"distances. This is the jackpot."));
			result = _tmp5_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Text and UI are likely to appear too small for typical viewing distanc" \
"es. Increasing the text size may help."));
			result = _tmp6_;
			return result;
		}
		case MAIN_WINDOW_RANGE_HIGH:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Text and UI will appear too small for typical viewing distances."));
			result = _tmp7_;
			return result;
		}
		case MAIN_WINDOW_RANGE_UNCLEAR:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("This display is in a very tricky range and is not likely to work well " \
"with integer scaling out of the box."));
			result = _tmp8_;
			return result;
		}
		case MAIN_WINDOW_RANGE_INVALID:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Enter details about a display to analyze it."));
			result = _tmp9_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static gchar*
main_window_range_icon (MainWindowRange self)
{
	gchar* result = NULL;
	switch (self) {
		case MAIN_WINDOW_RANGE_LOW:
		case MAIN_WINDOW_RANGE_HIGH:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("dialog-error");
			result = _tmp0_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_LOW:
		case MAIN_WINDOW_RANGE_LODPI_HIGH:
		case MAIN_WINDOW_RANGE_HIDPI_LOW:
		case MAIN_WINDOW_RANGE_HIDPI_HIGH:
		case MAIN_WINDOW_RANGE_UNCLEAR:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("dialog-warning");
			result = _tmp1_;
			return result;
		}
		case MAIN_WINDOW_RANGE_LODPI_IDEAL:
		case MAIN_WINDOW_RANGE_HIDPI_IDEAL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("process-completed");
			result = _tmp2_;
			return result;
		}
		case MAIN_WINDOW_RANGE_INVALID:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("dialog-information");
			result = _tmp3_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
main_window_range_get_type_once (void)
{
	static const GEnumValue values[] = {{MAIN_WINDOW_RANGE_LOW, "MAIN_WINDOW_RANGE_LOW", "low"}, {MAIN_WINDOW_RANGE_LODPI_LOW, "MAIN_WINDOW_RANGE_LODPI_LOW", "lodpi-low"}, {MAIN_WINDOW_RANGE_LODPI_IDEAL, "MAIN_WINDOW_RANGE_LODPI_IDEAL", "lodpi-ideal"}, {MAIN_WINDOW_RANGE_LODPI_HIGH, "MAIN_WINDOW_RANGE_LODPI_HIGH", "lodpi-high"}, {MAIN_WINDOW_RANGE_HIDPI_LOW, "MAIN_WINDOW_RANGE_HIDPI_LOW", "hidpi-low"}, {MAIN_WINDOW_RANGE_HIDPI_IDEAL, "MAIN_WINDOW_RANGE_HIDPI_IDEAL", "hidpi-ideal"}, {MAIN_WINDOW_RANGE_HIDPI_HIGH, "MAIN_WINDOW_RANGE_HIDPI_HIGH", "hidpi-high"}, {MAIN_WINDOW_RANGE_HIGH, "MAIN_WINDOW_RANGE_HIGH", "high"}, {MAIN_WINDOW_RANGE_UNCLEAR, "MAIN_WINDOW_RANGE_UNCLEAR", "unclear"}, {MAIN_WINDOW_RANGE_INVALID, "MAIN_WINDOW_RANGE_INVALID", "invalid"}, {0, NULL, NULL}};
	GType main_window_range_type_id;
	main_window_range_type_id = g_enum_register_static ("MainWindowRange", values);
	return main_window_range_type_id;
}

static GType
main_window_range_get_type (void)
{
	static volatile gsize main_window_range_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_range_type_id__volatile)) {
		GType main_window_range_type_id;
		main_window_range_type_id = main_window_range_get_type_once ();
		g_once_init_leave (&main_window_range_type_id__volatile, main_window_range_type_id);
	}
	return main_window_range_type_id__volatile;
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MainWindow*) g_object_new (object_type, "application", application, "border-width", 0, "icon-name", "com.github.cassidyjames.dippi", "resizable", FALSE, "title", _ ("Dippi"), "window-position", GTK_WIN_POS_CENTER, NULL);
	return self;
}

MainWindow*
main_window_new (GtkApplication* application)
{
	return main_window_construct (TYPE_MAIN_WINDOW, application);
}

static gint
main_window_recalculate_dpi (MainWindow* self,
                             gdouble inches,
                             gint width,
                             gint height)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (inches > ((gdouble) 0)) {
		_tmp1_ = width > 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = height > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint calculated_dpi = 0;
		GtkLabel* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		calculated_dpi = utils_dpi (inches, width, height);
		_tmp2_ = self->priv->dpi_result_label;
		_tmp3_ = g_strdup_printf (_ ("%d DPI"), calculated_dpi);
		_tmp4_ = _tmp3_;
		gtk_label_set_label (_tmp2_, _tmp4_);
		_g_free0 (_tmp4_);
		main_window_recalculate_logical_resolution (self, width, height, calculated_dpi);
		result = calculated_dpi;
		return result;
	}
	_tmp5_ = self->priv->dpi_result_label;
	gtk_label_set_label (_tmp5_, "");
	_tmp6_ = self->priv->logical_resolution_label;
	gtk_label_set_label (_tmp6_, "");
	result = 0;
	return result;
}

static void
main_window_recalculate_aspect (MainWindow* self,
                                gint width,
                                gint height)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (width > 0) {
		_tmp0_ = height > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		self->priv->aspect_width = width / utils_greatest_common_divisor (width, height);
		self->priv->aspect_height = height / utils_greatest_common_divisor (width, height);
		_tmp1_ = self->priv->aspect_result_label;
		_tmp2_ = g_strdup_printf ("%i", self->priv->aspect_width);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strconcat (_tmp3_, _ (":"), NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%i", self->priv->aspect_height);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		gtk_label_set_label (_tmp1_, _tmp9_);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
	} else {
		GtkLabel* _tmp10_;
		_tmp10_ = self->priv->aspect_result_label;
		gtk_label_set_label (_tmp10_, "");
	}
}

static void
main_window_recalculate_logical_resolution (MainWindow* self,
                                            gint width,
                                            gint height,
                                            gint dpi)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (width > 0) {
		_tmp0_ = height > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		if (dpi >= MAIN_WINDOW_DPI_INFER_HIDPI) {
			gint scaling_factor = 0;
			gint logical_width = 0;
			gint logical_height = 0;
			GtkLabel* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			scaling_factor = 2;
			logical_width = (gint) (width / scaling_factor);
			logical_height = (gint) (height / scaling_factor);
			_tmp1_ = self->priv->logical_resolution_label;
			_tmp2_ = g_strdup_printf ("%d×%d@%dx", logical_width, logical_height, scaling_factor);
			_tmp3_ = _tmp2_;
			gtk_label_set_label (_tmp1_, _tmp3_);
			_g_free0 (_tmp3_);
		} else {
			GtkLabel* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = self->priv->logical_resolution_label;
			_tmp5_ = g_strdup_printf ("%d×%d", width, height);
			_tmp6_ = _tmp5_;
			gtk_label_set_label (_tmp4_, _tmp6_);
			_g_free0 (_tmp6_);
		}
	} else {
		GtkLabel* _tmp7_;
		_tmp7_ = self->priv->logical_resolution_label;
		gtk_label_set_label (_tmp7_, "");
	}
}

static void
main_window_assess_dpi (MainWindow* self,
                        gdouble calculated_dpi,
                        UtilsDisplayType display_type)
{
	gint ideal_dpi = 0;
	gint ideal_range = 0;
	gint unclear_range = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkImage* _tmp2_;
	MainWindowRange _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	MainWindowRange _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkLabel* _tmp10_;
	MainWindowRange _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	g_return_if_fail (self != NULL);
	ideal_dpi = MAIN_WINDOW_INTERNAL_IDEAL_DPI;
	ideal_range = MAIN_WINDOW_INTERNAL_IDEAL_RANGE;
	unclear_range = MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE;
	if (display_type == UTILS_DISPLAY_TYPE_EXTERNAL) {
		ideal_dpi = MAIN_WINDOW_EXTERNAL_IDEAL_DPI;
		ideal_range = MAIN_WINDOW_EXTERNAL_IDEAL_RANGE;
		unclear_range = MAIN_WINDOW_EXTERNAL_UNCLEAR_RANGE;
	}
	if (self->priv->inches == ((gdouble) 0)) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = self->priv->width == 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->height == 0;
	}
	if (_tmp0_) {
		self->priv->range = MAIN_WINDOW_RANGE_INVALID;
	} else {
		if (calculated_dpi < ((gdouble) ((ideal_dpi - ideal_range) - MAIN_WINDOW_INTERNAL_UNCLEAR_RANGE))) {
			self->priv->range = MAIN_WINDOW_RANGE_LOW;
		} else {
			if (calculated_dpi < ((gdouble) (ideal_dpi - ideal_range))) {
				self->priv->range = MAIN_WINDOW_RANGE_LODPI_LOW;
			} else {
				if (calculated_dpi <= ((gdouble) (ideal_dpi + ideal_range))) {
					self->priv->range = MAIN_WINDOW_RANGE_LODPI_IDEAL;
				} else {
					if (calculated_dpi <= ((gdouble) ((ideal_dpi + ideal_range) + unclear_range))) {
						self->priv->range = MAIN_WINDOW_RANGE_LODPI_HIGH;
					} else {
						if (calculated_dpi < ((gdouble) MAIN_WINDOW_DPI_INFER_HIDPI)) {
							self->priv->range = MAIN_WINDOW_RANGE_UNCLEAR;
						} else {
							if (calculated_dpi < ((gdouble) (((ideal_dpi - ideal_range) - unclear_range) * 2))) {
								self->priv->range = MAIN_WINDOW_RANGE_UNCLEAR;
							} else {
								if (calculated_dpi < ((gdouble) ((ideal_dpi - ideal_range) * 2))) {
									self->priv->range = MAIN_WINDOW_RANGE_HIDPI_LOW;
								} else {
									if (calculated_dpi <= ((gdouble) ((ideal_dpi + ideal_range) * 2))) {
										self->priv->range = MAIN_WINDOW_RANGE_HIDPI_IDEAL;
									} else {
										if (calculated_dpi <= ((gdouble) (((ideal_dpi + ideal_range) + unclear_range) * 2))) {
											self->priv->range = MAIN_WINDOW_RANGE_HIDPI_HIGH;
										} else {
											if (calculated_dpi > ((gdouble) (((ideal_dpi + ideal_range) + unclear_range) * 2))) {
												self->priv->range = MAIN_WINDOW_RANGE_HIGH;
											} else {
												self->priv->range = MAIN_WINDOW_RANGE_INVALID;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp2_ = self->priv->range_icon;
	_tmp3_ = self->priv->range;
	_tmp4_ = main_window_range_icon (_tmp3_);
	_tmp5_ = _tmp4_;
	g_object_set (_tmp2_, "icon-name", _tmp5_, NULL);
	_g_free0 (_tmp5_);
	_tmp6_ = self->priv->range_title_label;
	_tmp7_ = self->priv->range;
	_tmp8_ = main_window_range_title (_tmp7_);
	_tmp9_ = _tmp8_;
	gtk_label_set_label (_tmp6_, _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = self->priv->range_description_label;
	_tmp11_ = self->priv->range;
	_tmp12_ = main_window_range_description (_tmp11_);
	_tmp13_ = _tmp12_;
	gtk_label_set_label (_tmp10_, _tmp13_);
	_g_free0 (_tmp13_);
}

static UtilsDisplayType
main_window_infer_display_type (MainWindow* self,
                                gdouble inches)
{
	UtilsDisplayType _tmp2_;
	UtilsDisplayType result = 0;
	g_return_val_if_fail (self != NULL, 0);
	self->priv->is_default_display_type = TRUE;
	if (inches < ((gdouble) 18)) {
		GraniteWidgetsModeButton* _tmp0_;
		self->priv->display_type = UTILS_DISPLAY_TYPE_INTERNAL;
		_tmp0_ = self->priv->type_modebutton;
		granite_widgets_mode_button_set_selected (_tmp0_, 0);
	} else {
		GraniteWidgetsModeButton* _tmp1_;
		self->priv->display_type = UTILS_DISPLAY_TYPE_EXTERNAL;
		_tmp1_ = self->priv->type_modebutton;
		granite_widgets_mode_button_set_selected (_tmp1_, 1);
	}
	_tmp2_ = self->priv->display_type;
	result = _tmp2_;
	return result;
}

static void
main_window_set_display_icon (MainWindow* self)
{
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	UtilsDisplayType _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->diagram;
	_tmp1_ = self->priv->direction;
	_tmp2_ = g_strconcat ("display-measure-", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->display_type;
	_tmp5_ = utils_display_type_icon_suffix (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp3_, _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	g_object_set (_tmp0_, "icon-name", _tmp8_, NULL);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_main_window___lambda4_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = g_strdup ("diagonal");
	_g_free0 (self->priv->direction);
	self->priv->direction = _tmp0_;
	main_window_set_display_icon (self);
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
	result = _tmp1_;
	return result;
}

static gboolean
__main_window___lambda4__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda4_ ((MainWindow*) self, event);
	return result;
}

static gboolean
_main_window___lambda5_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = g_strdup ("horizontal");
	_g_free0 (self->priv->direction);
	self->priv->direction = _tmp0_;
	main_window_set_display_icon (self);
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
	result = _tmp1_;
	return result;
}

static gboolean
__main_window___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda5_ ((MainWindow*) self, event);
	return result;
}

static gboolean
_main_window___lambda6_ (MainWindow* self,
                         GdkEventFocus* event)
{
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = g_strdup ("vertical");
	_g_free0 (self->priv->direction);
	self->priv->direction = _tmp0_;
	main_window_set_display_icon (self);
	g_signal_emit_by_name ((GtkWidget*) self, "focus-in-event", event, &_tmp1_);
	result = _tmp1_;
	return result;
}

static gboolean
__main_window___lambda6__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                    GdkEventFocus* event,
                                                    gpointer self)
{
	gboolean result;
	result = _main_window___lambda6_ ((MainWindow*) self, event);
	return result;
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}

static void
_main_window___lambda7_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = self->priv->diag_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	self->priv->inches = double_parse (_tmp1_);
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), main_window_infer_display_type (self, self->priv->inches));
}

static void
__main_window___lambda7__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda7_ ((MainWindow*) self);
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static void
_main_window___lambda8_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	UtilsDisplayType _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkEntry* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = self->priv->width_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	self->priv->width = atoi (_tmp1_);
	self->priv->is_default_width = FALSE;
	main_window_recalculate_aspect (self, self->priv->width, self->priv->height);
	_tmp2_ = self->priv->display_type;
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), _tmp2_);
	_tmp4_ = self->priv->height_entry;
	g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
	_tmp6_ = _tmp5_;
	if (!_tmp6_) {
		gboolean _tmp7_ = FALSE;
		if (self->priv->is_default_height) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = self->priv->height == 0;
		}
		_tmp3_ = _tmp7_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gdouble calculated_height = 0.0;
		GtkEntry* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		calculated_height = round ((gdouble) ((self->priv->width * MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT) / MAIN_WINDOW_DEFAULT_ASPECT_WIDTH));
		_tmp8_ = self->priv->height_entry;
		_tmp9_ = double_to_string (calculated_height);
		_tmp10_ = _tmp9_;
		gtk_entry_set_text (_tmp8_, _tmp10_);
		_g_free0 (_tmp10_);
		self->priv->is_default_height = TRUE;
	}
}

static void
__main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda8_ ((MainWindow*) self);
}

static void
_main_window___lambda9_ (MainWindow* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	UtilsDisplayType _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkEntry* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = self->priv->height_entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	self->priv->height = atoi (_tmp1_);
	self->priv->is_default_height = FALSE;
	main_window_recalculate_aspect (self, self->priv->width, self->priv->height);
	_tmp2_ = self->priv->display_type;
	main_window_assess_dpi (self, (gdouble) main_window_recalculate_dpi (self, self->priv->inches, self->priv->width, self->priv->height), _tmp2_);
	_tmp4_ = self->priv->width_entry;
	g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
	_tmp6_ = _tmp5_;
	if (!_tmp6_) {
		gboolean _tmp7_ = FALSE;
		if (self->priv->is_default_width) {
			_tmp7_ = TRUE;
		} else {
			_tmp7_ = self->priv->width == 0;
		}
		_tmp3_ = _tmp7_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gdouble calculated_width = 0.0;
		GtkEntry* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		calculated_width = round ((gdouble) ((self->priv->height * MAIN_WINDOW_DEFAULT_ASPECT_WIDTH) / MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT));
		_tmp8_ = self->priv->width_entry;
		_tmp9_ = double_to_string (calculated_width);
		_tmp10_ = _tmp9_;
		gtk_entry_set_text (_tmp8_, _tmp10_);
		_g_free0 (_tmp10_);
		self->priv->is_default_width = TRUE;
	}
}

static void
__main_window___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda9_ ((MainWindow*) self);
}

static void
_main_window___lambda10_ (MainWindow* self)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	UtilsDisplayType _tmp3_;
	_tmp0_ = self->priv->type_modebutton;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 0:
		{
			self->priv->display_type = UTILS_DISPLAY_TYPE_INTERNAL;
			break;
		}
		case 1:
		{
			self->priv->display_type = UTILS_DISPLAY_TYPE_EXTERNAL;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp3_ = self->priv->display_type;
	main_window_assess_dpi (self, (gdouble) utils_dpi (self->priv->inches, self->priv->width, self->priv->height), _tmp3_);
	main_window_set_display_icon (self);
}

static void
__main_window___lambda10__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                                    GtkWidget* widget,
                                                                    gpointer self)
{
	_main_window___lambda10_ ((MainWindow*) self);
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkHeaderBar* header = NULL;
	GtkHeaderBar* _tmp2_;
	GtkHeaderBar* _tmp3_;
	GtkStyleContext* header_context = NULL;
	GtkHeaderBar* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* diag_label = NULL;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkLabel* res_label = NULL;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
	GtkEntry* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
	GtkLabel* x_label = NULL;
	GtkLabel* _tmp32_;
	GtkLabel* px_label = NULL;
	GtkLabel* _tmp33_;
	GtkLabel* inches_label = NULL;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* type_label = NULL;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GraniteWidgetsModeButton* _tmp38_;
	GraniteWidgetsModeButton* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	GraniteWidgetsModeButton* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	GtkImage* _tmp57_;
	GtkImage* _tmp58_;
	GtkImage* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkLabel* _tmp63_;
	GtkLabel* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkLabel* _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkLabel* _tmp73_;
	GtkLabel* _tmp74_;
	GtkLabel* _tmp75_;
	GtkLabel* _tmp76_;
	GtkLabel* _tmp77_;
	GtkLabel* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	GtkEntry* _tmp81_;
	GtkEntry* _tmp82_;
	GtkEntry* _tmp83_;
	GraniteWidgetsModeButton* _tmp84_;
	GtkGrid* data_grid = NULL;
	GtkGrid* _tmp85_;
	GtkGrid* _tmp86_;
	GtkGrid* _tmp87_;
	GtkGrid* _tmp88_;
	GtkGrid* _tmp89_;
	GtkGrid* _tmp90_;
	GtkStyleContext* _tmp91_;
	GtkGrid* _tmp92_;
	GtkImage* _tmp93_;
	GtkGrid* _tmp94_;
	GtkLabel* _tmp95_;
	GtkGrid* _tmp96_;
	GtkEntry* _tmp97_;
	GtkGrid* _tmp98_;
	GtkLabel* _tmp99_;
	GtkGrid* _tmp100_;
	GtkLabel* _tmp101_;
	GtkGrid* _tmp102_;
	GtkEntry* _tmp103_;
	GtkGrid* _tmp104_;
	GtkLabel* _tmp105_;
	GtkGrid* _tmp106_;
	GtkEntry* _tmp107_;
	GtkGrid* _tmp108_;
	GtkLabel* _tmp109_;
	GtkGrid* _tmp110_;
	GtkLabel* _tmp111_;
	GtkGrid* _tmp112_;
	GraniteWidgetsModeButton* _tmp113_;
	GtkGrid* assessment_grid = NULL;
	GtkGrid* _tmp114_;
	GtkGrid* _tmp115_;
	GtkGrid* _tmp116_;
	GtkGrid* _tmp117_;
	GtkGrid* _tmp118_;
	GtkGrid* _tmp119_;
	GtkGrid* _tmp120_;
	GtkGrid* _tmp121_;
	GtkStyleContext* _tmp122_;
	GtkGrid* _tmp123_;
	GtkImage* _tmp124_;
	GtkGrid* _tmp125_;
	GtkLabel* _tmp126_;
	GtkGrid* _tmp127_;
	GtkLabel* _tmp128_;
	GtkGrid* _tmp129_;
	GtkLabel* _tmp130_;
	GtkGrid* _tmp131_;
	GtkLabel* _tmp132_;
	GtkGrid* _tmp133_;
	GtkLabel* _tmp134_;
	GtkGrid* main_layout = NULL;
	GtkGrid* _tmp135_;
	GtkGrid* _tmp136_;
	GtkGrid* _tmp137_;
	GtkGrid* _tmp138_;
	GtkGrid* _tmp139_;
	GtkGrid* _tmp140_;
	GtkGrid* _tmp141_;
	GtkGrid* _tmp142_;
	GtkGrid* _tmp143_;
	GtkEntry* _tmp144_;
	GtkStyleContext* _tmp145_;
	GtkStyleContext* _tmp146_;
	GtkHeaderBar* _tmp147_;
	GtkGrid* _tmp148_;
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_tmp0_ = gtk_icon_theme_get_default ();
	default_theme = _tmp0_;
	_tmp1_ = default_theme;
	gtk_icon_theme_add_resource_path (_tmp1_, "/com/github/cassidyjames/dippi");
	_tmp2_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp2_);
	header = _tmp2_;
	_tmp3_ = header;
	gtk_header_bar_set_show_close_button (_tmp3_, TRUE);
	_tmp4_ = header;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	header_context = _tmp6_;
	_tmp7_ = header_context;
	gtk_style_context_add_class (_tmp7_, "titlebar");
	_tmp8_ = header_context;
	gtk_style_context_add_class (_tmp8_, "default-decoration");
	_tmp9_ = header_context;
	gtk_style_context_add_class (_tmp9_, GTK_STYLE_CLASS_FLAT);
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("com.github.cassidyjames.dippi", (GtkIconSize) GTK_ICON_SIZE_INVALID);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->diagram);
	self->priv->diagram = _tmp10_;
	_tmp11_ = self->priv->diagram;
	gtk_image_set_pixel_size (_tmp11_, 128);
	_tmp12_ = self->priv->diagram;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp12_, 12);
	_tmp13_ = (GtkLabel*) gtk_label_new (_ ("Diagonal size:"));
	g_object_ref_sink (_tmp13_);
	diag_label = _tmp13_;
	_tmp14_ = diag_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_END);
	_tmp15_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->diag_entry);
	self->priv->diag_entry = _tmp15_;
	_tmp16_ = self->priv->diag_entry;
	gtk_entry_set_max_length (_tmp16_, 5);
	_tmp17_ = self->priv->diag_entry;
	gtk_entry_set_max_width_chars (_tmp17_, 5);
	_tmp18_ = self->priv->diag_entry;
	gtk_entry_set_width_chars (_tmp18_, 5);
	_tmp19_ = self->priv->diag_entry;
	g_signal_connect_object ((GtkWidget*) _tmp19_, "focus-in-event", (GCallback) __main_window___lambda4__gtk_widget_focus_in_event, self, 0);
	_tmp20_ = (GtkLabel*) gtk_label_new (_ ("Resolution:"));
	g_object_ref_sink (_tmp20_);
	res_label = _tmp20_;
	_tmp21_ = res_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
	_tmp22_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->width_entry);
	self->priv->width_entry = _tmp22_;
	_tmp23_ = self->priv->width_entry;
	gtk_entry_set_max_length (_tmp23_, 5);
	_tmp24_ = self->priv->width_entry;
	gtk_entry_set_max_width_chars (_tmp24_, 5);
	_tmp25_ = self->priv->width_entry;
	gtk_entry_set_width_chars (_tmp25_, 5);
	_tmp26_ = self->priv->width_entry;
	g_signal_connect_object ((GtkWidget*) _tmp26_, "focus-in-event", (GCallback) __main_window___lambda5__gtk_widget_focus_in_event, self, 0);
	_tmp27_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->height_entry);
	self->priv->height_entry = _tmp27_;
	_tmp28_ = self->priv->height_entry;
	gtk_entry_set_max_length (_tmp28_, 5);
	_tmp29_ = self->priv->height_entry;
	gtk_entry_set_max_width_chars (_tmp29_, 5);
	_tmp30_ = self->priv->height_entry;
	gtk_entry_set_width_chars (_tmp30_, 5);
	_tmp31_ = self->priv->height_entry;
	g_signal_connect_object ((GtkWidget*) _tmp31_, "focus-in-event", (GCallback) __main_window___lambda6__gtk_widget_focus_in_event, self, 0);
	_tmp32_ = (GtkLabel*) gtk_label_new (_ ("×"));
	g_object_ref_sink (_tmp32_);
	x_label = _tmp32_;
	_tmp33_ = (GtkLabel*) gtk_label_new (_ ("px"));
	g_object_ref_sink (_tmp33_);
	px_label = _tmp33_;
	_tmp34_ = (GtkLabel*) gtk_label_new (_ ("inches"));
	g_object_ref_sink (_tmp34_);
	inches_label = _tmp34_;
	_tmp35_ = inches_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp35_, GTK_ALIGN_START);
	_tmp36_ = (GtkLabel*) gtk_label_new (_ ("Type:"));
	g_object_ref_sink (_tmp36_);
	type_label = _tmp36_;
	_tmp37_ = type_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp37_, GTK_ALIGN_END);
	_tmp38_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->type_modebutton);
	self->priv->type_modebutton = _tmp38_;
	_tmp39_ = self->priv->type_modebutton;
	_tmp40_ = utils_display_type_to_string (UTILS_DISPLAY_TYPE_INTERNAL);
	_tmp41_ = _tmp40_;
	granite_widgets_mode_button_append_text (_tmp39_, _tmp41_);
	_g_free0 (_tmp41_);
	_tmp42_ = self->priv->type_modebutton;
	_tmp43_ = utils_display_type_to_string (UTILS_DISPLAY_TYPE_EXTERNAL);
	_tmp44_ = _tmp43_;
	granite_widgets_mode_button_append_text (_tmp42_, _tmp44_);
	_g_free0 (_tmp44_);
	_tmp45_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp45_);
	_g_object_unref0 (self->priv->aspect_result_label);
	self->priv->aspect_result_label = _tmp45_;
	_tmp46_ = self->priv->aspect_result_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_START);
	_tmp47_ = self->priv->aspect_result_label;
	gtk_label_set_selectable (_tmp47_, TRUE);
	_tmp48_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp48_);
	_g_object_unref0 (self->priv->dpi_result_label);
	self->priv->dpi_result_label = _tmp48_;
	_tmp49_ = self->priv->dpi_result_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp49_, GTK_ALIGN_START);
	_tmp50_ = self->priv->dpi_result_label;
	gtk_label_set_selectable (_tmp50_, TRUE);
	_tmp51_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp51_);
	_g_object_unref0 (self->priv->logical_resolution_label);
	self->priv->logical_resolution_label = _tmp51_;
	_tmp52_ = self->priv->logical_resolution_label;
	g_object_set ((GtkWidget*) _tmp52_, "expand", TRUE, NULL);
	_tmp53_ = self->priv->logical_resolution_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
	_tmp54_ = self->priv->logical_resolution_label;
	gtk_label_set_selectable (_tmp54_, TRUE);
	_tmp55_ = main_window_range_icon (MAIN_WINDOW_RANGE_INVALID);
	_tmp56_ = _tmp55_;
	_tmp57_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp56_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->range_icon);
	self->priv->range_icon = _tmp57_;
	_g_free0 (_tmp56_);
	_tmp58_ = self->priv->range_icon;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp58_, 12);
	_tmp59_ = self->priv->range_icon;
	gtk_widget_set_valign ((GtkWidget*) _tmp59_, GTK_ALIGN_START);
	_tmp60_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp60_);
	_g_object_unref0 (self->priv->range_title_label);
	self->priv->range_title_label = _tmp60_;
	_tmp61_ = self->priv->range_title_label;
	g_object_set (_tmp61_, "wrap", TRUE, NULL);
	_tmp62_ = self->priv->range_title_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_START);
	_tmp63_ = self->priv->range_title_label;
	gtk_label_set_selectable (_tmp63_, TRUE);
	_tmp64_ = self->priv->range_title_label;
	gtk_label_set_xalign (_tmp64_, (gfloat) 0);
	_tmp65_ = self->priv->range_title_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp65_, GTK_ALIGN_END);
	_tmp66_ = self->priv->range_title_label;
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
	gtk_style_context_add_class (_tmp67_, "h2");
	_tmp68_ = self->priv->range_title_label;
	_tmp69_ = main_window_range_title (MAIN_WINDOW_RANGE_INVALID);
	_tmp70_ = _tmp69_;
	gtk_label_set_label (_tmp68_, _tmp70_);
	_g_free0 (_tmp70_);
	_tmp71_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp71_);
	_g_object_unref0 (self->priv->range_description_label);
	self->priv->range_description_label = _tmp71_;
	_tmp72_ = self->priv->range_description_label;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp72_, 12);
	_tmp73_ = self->priv->range_description_label;
	gtk_label_set_max_width_chars (_tmp73_, 50);
	_tmp74_ = self->priv->range_description_label;
	gtk_label_set_selectable (_tmp74_, TRUE);
	_tmp75_ = self->priv->range_description_label;
	g_object_set (_tmp75_, "wrap", TRUE, NULL);
	_tmp76_ = self->priv->range_description_label;
	gtk_label_set_xalign (_tmp76_, (gfloat) 0);
	_tmp77_ = self->priv->range_description_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp77_, GTK_ALIGN_START);
	_tmp78_ = self->priv->range_description_label;
	_tmp79_ = main_window_range_description (MAIN_WINDOW_RANGE_INVALID);
	_tmp80_ = _tmp79_;
	gtk_label_set_label (_tmp78_, _tmp80_);
	_g_free0 (_tmp80_);
	_tmp81_ = self->priv->diag_entry;
	g_signal_connect_object ((GtkEditable*) _tmp81_, "changed", (GCallback) __main_window___lambda7__gtk_editable_changed, self, 0);
	_tmp82_ = self->priv->width_entry;
	g_signal_connect_object ((GtkEditable*) _tmp82_, "changed", (GCallback) __main_window___lambda8__gtk_editable_changed, self, 0);
	_tmp83_ = self->priv->height_entry;
	g_signal_connect_object ((GtkEditable*) _tmp83_, "changed", (GCallback) __main_window___lambda9__gtk_editable_changed, self, 0);
	_tmp84_ = self->priv->type_modebutton;
	g_signal_connect_object (_tmp84_, "mode-changed", (GCallback) __main_window___lambda10__granite_widgets_mode_button_mode_changed, self, 0);
	_tmp85_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp85_);
	data_grid = _tmp85_;
	_tmp86_ = data_grid;
	gtk_grid_set_column_spacing (_tmp86_, 6);
	_tmp87_ = data_grid;
	g_object_set ((GtkWidget*) _tmp87_, "margin", 24, NULL);
	_tmp88_ = data_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp88_, 0);
	_tmp89_ = data_grid;
	gtk_grid_set_row_spacing (_tmp89_, 6);
	_tmp90_ = data_grid;
	_tmp91_ = gtk_widget_get_style_context ((GtkWidget*) _tmp90_);
	gtk_style_context_add_class (_tmp91_, "data-grid");
	_tmp92_ = data_grid;
	_tmp93_ = self->priv->diagram;
	gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 0, 0, 5, 1);
	_tmp94_ = data_grid;
	_tmp95_ = diag_label;
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 0, 1, 1, 1);
	_tmp96_ = data_grid;
	_tmp97_ = self->priv->diag_entry;
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 1, 1, 1, 1);
	_tmp98_ = data_grid;
	_tmp99_ = inches_label;
	gtk_grid_attach (_tmp98_, (GtkWidget*) _tmp99_, 2, 1, 2, 1);
	_tmp100_ = data_grid;
	_tmp101_ = res_label;
	gtk_grid_attach (_tmp100_, (GtkWidget*) _tmp101_, 0, 2, 1, 1);
	_tmp102_ = data_grid;
	_tmp103_ = self->priv->width_entry;
	gtk_grid_attach (_tmp102_, (GtkWidget*) _tmp103_, 1, 2, 1, 1);
	_tmp104_ = data_grid;
	_tmp105_ = x_label;
	gtk_grid_attach (_tmp104_, (GtkWidget*) _tmp105_, 2, 2, 1, 1);
	_tmp106_ = data_grid;
	_tmp107_ = self->priv->height_entry;
	gtk_grid_attach (_tmp106_, (GtkWidget*) _tmp107_, 3, 2, 1, 1);
	_tmp108_ = data_grid;
	_tmp109_ = px_label;
	gtk_grid_attach (_tmp108_, (GtkWidget*) _tmp109_, 4, 2, 1, 1);
	_tmp110_ = data_grid;
	_tmp111_ = type_label;
	gtk_grid_attach (_tmp110_, (GtkWidget*) _tmp111_, 0, 3, 1, 1);
	_tmp112_ = data_grid;
	_tmp113_ = self->priv->type_modebutton;
	gtk_grid_attach (_tmp112_, (GtkWidget*) _tmp113_, 1, 3, 4, 1);
	_tmp114_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp114_);
	assessment_grid = _tmp114_;
	_tmp115_ = assessment_grid;
	gtk_grid_set_column_spacing (_tmp115_, 12);
	_tmp116_ = assessment_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp116_, GTK_ALIGN_START);
	_tmp117_ = assessment_grid;
	g_object_set ((GtkWidget*) _tmp117_, "margin", 12, NULL);
	_tmp118_ = assessment_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp118_, 48);
	_tmp119_ = assessment_grid;
	gtk_grid_set_row_spacing (_tmp119_, 6);
	_tmp120_ = assessment_grid;
	gtk_widget_set_valign ((GtkWidget*) _tmp120_, GTK_ALIGN_START);
	_tmp121_ = assessment_grid;
	_tmp122_ = gtk_widget_get_style_context ((GtkWidget*) _tmp121_);
	gtk_style_context_add_class (_tmp122_, "assessment-grid");
	_tmp123_ = assessment_grid;
	_tmp124_ = self->priv->range_icon;
	gtk_grid_attach (_tmp123_, (GtkWidget*) _tmp124_, 0, 0, 1, 2);
	_tmp125_ = assessment_grid;
	_tmp126_ = self->priv->range_title_label;
	gtk_grid_attach (_tmp125_, (GtkWidget*) _tmp126_, 1, 0, 3, 1);
	_tmp127_ = assessment_grid;
	_tmp128_ = self->priv->range_description_label;
	gtk_grid_attach (_tmp127_, (GtkWidget*) _tmp128_, 1, 1, 3, 1);
	_tmp129_ = assessment_grid;
	_tmp130_ = self->priv->aspect_result_label;
	gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, 1, 2, 1, 1);
	_tmp131_ = assessment_grid;
	_tmp132_ = self->priv->dpi_result_label;
	gtk_grid_attach (_tmp131_, (GtkWidget*) _tmp132_, 2, 2, 1, 1);
	_tmp133_ = assessment_grid;
	_tmp134_ = self->priv->logical_resolution_label;
	gtk_grid_attach (_tmp133_, (GtkWidget*) _tmp134_, 3, 2, 1, 1);
	_tmp135_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp135_);
	main_layout = _tmp135_;
	_tmp136_ = main_layout;
	gtk_grid_set_column_spacing (_tmp136_, 6);
	_tmp137_ = main_layout;
	g_object_set ((GtkWidget*) _tmp137_, "height-request", 258, NULL);
	_tmp138_ = main_layout;
	gtk_grid_set_row_spacing (_tmp138_, 6);
	_tmp139_ = main_layout;
	g_object_set ((GtkWidget*) _tmp139_, "width-request", 710, NULL);
	_tmp140_ = main_layout;
	_tmp141_ = data_grid;
	gtk_grid_attach (_tmp140_, (GtkWidget*) _tmp141_, 0, 0, 1, 1);
	_tmp142_ = main_layout;
	_tmp143_ = assessment_grid;
	gtk_grid_attach (_tmp142_, (GtkWidget*) _tmp143_, 1, 0, 1, 1);
	_tmp144_ = self->priv->diag_entry;
	gtk_widget_grab_focus ((GtkWidget*) _tmp144_);
	_tmp145_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp145_, "dippi");
	_tmp146_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp146_, "rounded");
	_tmp147_ = header;
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp147_);
	_tmp148_ = main_layout;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp148_);
	_g_object_unref0 (main_layout);
	_g_object_unref0 (assessment_grid);
	_g_object_unref0 (data_grid);
	_g_object_unref0 (type_label);
	_g_object_unref0 (inches_label);
	_g_object_unref0 (px_label);
	_g_object_unref0 (x_label);
	_g_object_unref0 (res_label);
	_g_object_unref0 (diag_label);
	_g_object_unref0 (header_context);
	_g_object_unref0 (header);
	return obj;
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
	main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	self->priv = main_window_get_instance_private (self);
	self->priv->aspect_width = MAIN_WINDOW_DEFAULT_ASPECT_WIDTH;
	self->priv->aspect_height = MAIN_WINDOW_DEFAULT_ASPECT_HEIGHT;
	self->priv->inches = 0.0;
	self->priv->width = 0;
	self->priv->height = 0;
	self->priv->is_default_display_type = TRUE;
	self->priv->is_default_width = TRUE;
	self->priv->is_default_height = TRUE;
	_tmp0_ = g_strdup ("");
	self->priv->direction = _tmp0_;
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_g_free0 (self->priv->direction);
	_g_object_unref0 (self->priv->diagram);
	_g_object_unref0 (self->priv->diag_entry);
	_g_object_unref0 (self->priv->width_entry);
	_g_object_unref0 (self->priv->height_entry);
	_g_object_unref0 (self->priv->dpi_result_label);
	_g_object_unref0 (self->priv->logical_resolution_label);
	_g_object_unref0 (self->priv->aspect_result_label);
	_g_object_unref0 (self->priv->type_modebutton);
	_g_object_unref0 (self->priv->range_title_label);
	_g_object_unref0 (self->priv->range_description_label);
	_g_object_unref0 (self->priv->range_icon);
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
}

static GType
main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
	GType main_window_type_id;
	main_window_type_id = g_type_register_static (gtk_window_get_type (), "MainWindow", &g_define_type_info, 0);
	MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
	return main_window_type_id;
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		GType main_window_type_id;
		main_window_type_id = main_window_get_type_once ();
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}

