/* Utils.c generated by valac 0.48.13, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright © 2018–2020 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

typedef enum  {
	UTILS_DISPLAY_TYPE_INTERNAL,
	UTILS_DISPLAY_TYPE_EXTERNAL
} UtilsDisplayType;

#define UTILS_TYPE_DISPLAY_TYPE (utils_display_type_get_type ())

GType utils_display_type_get_type (void) G_GNUC_CONST;
gchar* utils_display_type_to_string (UtilsDisplayType self);
gchar* utils_display_type_icon_suffix (UtilsDisplayType self);
gint utils_dpi (gdouble inches,
                gint width,
                gint height);
gint utils_greatest_common_divisor (gint a,
                                    gint b);

gchar*
utils_display_type_to_string (UtilsDisplayType self)
{
	gchar* result = NULL;
	switch (self) {
		case UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Laptop"));
			result = _tmp0_;
			return result;
		}
		case UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Desktop"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
utils_display_type_icon_suffix (UtilsDisplayType self)
{
	gchar* result = NULL;
	switch (self) {
		case UTILS_DISPLAY_TYPE_INTERNAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("-notebook");
			result = _tmp0_;
			return result;
		}
		case UTILS_DISPLAY_TYPE_EXTERNAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("");
			result = _tmp1_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
utils_display_type_get_type_once (void)
{
	static const GEnumValue values[] = {{UTILS_DISPLAY_TYPE_INTERNAL, "UTILS_DISPLAY_TYPE_INTERNAL", "internal"}, {UTILS_DISPLAY_TYPE_EXTERNAL, "UTILS_DISPLAY_TYPE_EXTERNAL", "external"}, {0, NULL, NULL}};
	GType utils_display_type_type_id;
	utils_display_type_type_id = g_enum_register_static ("UtilsDisplayType", values);
	return utils_display_type_type_id;
}

GType
utils_display_type_get_type (void)
{
	static volatile gsize utils_display_type_type_id__volatile = 0;
	if (g_once_init_enter (&utils_display_type_type_id__volatile)) {
		GType utils_display_type_type_id;
		utils_display_type_type_id = utils_display_type_get_type_once ();
		g_once_init_leave (&utils_display_type_type_id__volatile, utils_display_type_type_id);
	}
	return utils_display_type_type_id__volatile;
}

gint
utils_dpi (gdouble inches,
           gint width,
           gint height)
{
	gdouble unrounded_dpi = 0.0;
	gint rounded_dpi = 0;
	gint result = 0;
	unrounded_dpi = sqrt (pow ((gdouble) width, (gdouble) 2) + pow ((gdouble) height, (gdouble) 2)) / inches;
	rounded_dpi = (gint) unrounded_dpi;
	result = rounded_dpi;
	return result;
}

gint
utils_greatest_common_divisor (gint a,
                               gint b)
{
	gint result = 0;
	if (a == 0) {
		result = b;
		return result;
	}
	if (b == 0) {
		result = a;
		return result;
	}
	if (a > b) {
		result = utils_greatest_common_divisor (a % b, b);
		return result;
	} else {
		result = utils_greatest_common_divisor (a, b % a);
		return result;
	}
}

